package com.tr.tms.abstractionLayer;

import java.util.*;

/**
 * Created by Benny.Vaknin on 27/11/2014.
 */
public class CalaisModel {
    private Map<String, CalaisObject> classesById = new HashMap<>();//key=id, value=CalaisObject
    private Map<String, List<CalaisObject>> classesByType = new HashMap<>();//key=field name, value=field values

    public void addCalaisObject(CalaisObject calaisObject){
        classesById.put(calaisObject.getObjectId(), calaisObject);
        final String type = calaisObject.getType();
        List<CalaisObject> objectsByType = classesByType.get(type);
        if(objectsByType == null){
            objectsByType = new ArrayList<>();
            classesByType.put(type, objectsByType);
        }
        objectsByType.add(calaisObject);
    }

    public CalaisObject getCalaisObjectById(String id){
        if(id == null || id.isEmpty() ){
            return null;
        }
        return classesById.get(id);
    }

    public List<CalaisObject> getCalaisObjectByType(String type){
        if(type == null || type.isEmpty() ){
            return null;
        }
        return classesByType.get(type);
    }

    public Set<String> getAllTypes(){
        return classesByType.keySet();
    }
	
    public List<CalaisObject> getAllCalaisObjects(){
		return new ArrayList<CalaisObject>(classesById.values());
	}


}
