package com.tr.tms.abstractionLayer.engine;

import java.io.InputStream;
import com.tr.tms.abstractionLayer.CalaisModel;

public interface Engine{
	public enum Format {   
		RDF("RDF/XML"),
		N3("N3");
		private String format;
		 
	    private Format(String format) {
	    this.format = format;
	    }

	    public String getValue() {
	    	return format;
	    }
	}
	/**
	 * receive RDF as input stream, process it and return a CalaisModel  
	 * @param inputStream
	 * @param inputFormat - the format is RDF or N3
	 * @return
	 */
    public CalaisModel process(InputStream inputStream, Format inputFormat);
	
    /**
     * receive RDF as string, process it and return a CalaisModel  
     * @param rdfText
     * @param inputFormat - the format is RDF or N3
     * @return
     */
    public CalaisModel process(String rdfText, Format inputFormat);
    
}
